extends Node2D

const fadeTime = 1.4
const cameraPosition = Vector2(0, 0)
const cameraZoom = Vector2(1.5, 1.5)
const cameraTime = 2.0

func _ready():
	if not get_tree().root.has_node("Root"):
		return ;
	
	GallerySingleton.AddImage("Linda_sex");
	
	if Dialogic.get_variable("SexSpriteNumber") == "1":
		self.scale = cameraZoom
	elif Dialogic.get_variable("SexSpriteNumber") == "2":
		$Sprite1.visible = false
	elif Dialogic.get_variable("SexSpriteNumber") == "3":
		$Sprite1.visible = false
		self.position = cameraPosition
		self.scale = cameraZoom
	elif Dialogic.get_variable("SexSpriteNumber") == "4":
		self.scale = Vector2(1.0, 1.0)

	var dialogicNode = get_parent().get_parent().get_node("Game").get_child(0).get_child(0)
	dialogicNode.connect("dialogic_signal", self, "_slideswitch_listener")

	






func _slideswitch_listener(string):
	match string:
		"sprite2":
			Dialogic.set_variable("SexSpriteNumber", 2)
			var tween = $"Tween"
			tween.interpolate_method(self, "Sprite1Interpolate", 1, 0, fadeTime, Tween.TRANS_LINEAR, 0)
			tween.start()
		"camera_zoom":
			Dialogic.set_variable("SexSpriteNumber", 3)
			var tween = $"Tween"
			
			tween.interpolate_property(self, "scale", self.scale, cameraZoom, cameraTime, Tween.TRANS_LINEAR, 0)
			tween.start()
		"camera_zoom_out":
			Dialogic.set_variable("SexSpriteNumber", 4)
			var tween = $"Tween"
			
			tween.interpolate_property(self, "scale", self.scale, Vector2(1.0, 1.0), cameraTime, Tween.TRANS_LINEAR, 0)
			tween.start()

func Sprite1Interpolate(value):
	$Sprite1.self_modulate.a = value

func InitForGallery()->Array:
	scale = Vector2(0.5, 0.5)
	
	return ["ui_gallery_fall_1", "ui_gallery_fall_2"];
	
func SetSettings(setting):
	if setting == tr("ui_gallery_fall_1"):
		$Sprite.visible = false;
		$Sprite1.visible = true;
	elif setting == tr("ui_gallery_fall_2"):
		$Sprite.visible = true;
		$Sprite1.visible = false;
