extends Node2D

var isGlock:bool

func _ready():
	if not get_tree().root.has_node("Root"):
		return ;
	
	GallerySingleton.AddImage("Pistol");
	
	var sfxPath = "res://resources/audio/sfx/Rain Loop.ogg"
	get_tree().root.get_node("Root").SetSFXforBGM(sfxPath)
	
	if int(Dialogic.get_variable("Is_White_Dead")) == 0:
		$white.visible = true
		isGlock = true
		GallerySingleton.AddImage("Pistol_White");
	if int(Dialogic.get_variable("Is_Red_Dead")) == 0:
		$red.visible = true
		isGlock = false
		GallerySingleton.AddImage("Pistol_Red");
	
	if Dialogic.get_variable("Killer") == "Pink":
		if int(Dialogic.get_variable("NoGirl")) == 0:
			$pink.visible = true
			if isGlock:
				$pink / glock.visible = true
			else :
				$pink / beretta.visible = true
		
		GallerySingleton.AddImage("Pistol_Pink");
	if Dialogic.get_variable("Killer") == "Blue":
		if int(Dialogic.get_variable("NoGirl")) == 0:
			$blue.visible = true
			if isGlock:
				$pink / glock.visible = true
			else :
				$pink / beretta.visible = true
		
		GallerySingleton.AddImage("Pistol_Blue");

var isPink;
var isWhite;

func InitForGallery()->Array:
	scale = Vector2(0.5, 0.5)
	
	var res = [];
	
	var glock = GallerySingleton.HaveImage("Pistol_White")
	var beretta = GallerySingleton.HaveImage("Pistol_Red")
	
	if glock and beretta:
		isGlock = true;
		isWhite = true;
		res.push_back("ui_gallery_pistol");
		res.push_back("ui_gallery_victim");
	elif glock and not beretta:
		isGlock = true;
		isWhite = true;
	else :
		isGlock = false;
		isWhite = false;
	
	var pink = GallerySingleton.HaveImage("Pistol_Pink")
	var blue = GallerySingleton.HaveImage("Pistol_Blue")
	
	if pink and blue:
		isPink = true;
		res.push_back("ui_gallery_girl");
	elif pink and not blue:
		isPink = true;
	else :
		isPink = false;
	
	SetScene()
	
	return res;

func SetScene():
	if isWhite:
		$white.visible = true;
		$red.visible = false;
	else :
		$white.visible = false;
		$red.visible = true;
	
	if isPink:
		$pink.visible = true;
		$blue.visible = false;
	else :
		$pink.visible = false;
		$blue.visible = true;
	
	if isGlock:
		$pink / glock.visible = true;
		$blue / glock.visible = true;
		$pink / beretta.visible = false;
		$blue / beretta.visible = false;
	else :
		$pink / glock.visible = false;
		$blue / glock.visible = false;
		$pink / beretta.visible = true;
		$blue / beretta.visible = true;

func SetToggleSettings(button):
	var text = button.text;
	var state = button.pressed;
	if text == tr("ui_gallery_pistol"):
		isGlock = not state;
	if text == tr("ui_gallery_victim"):
		isWhite = not state;
	if text == tr("ui_gallery_girl"):
		isPink = not state;
	
	SetScene()
	
